// SCDll.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "SCDll.h"

//SHARED DATA
#pragma data_seg(".SHARDATA")

static HWND g_hMyWnd= NULL;//handle of window that receives closed events
static HWND g_hSubWnd= NULL;//handle of subclassed window
static HHOOK g_hMyHook= NULL;//handle of 'dumb' hook

#pragma data_seg()

HMODULE hMyModule= NULL;
BOOL bIsInjected= FALSE;
LONG lOldWndProc= 0;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{	switch (ul_reason_for_call)
	{	
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
		//Find the window to be subclassed in this thread then subclass it
		EnumThreadWindows(GetCurrentThreadId(),EnumProc, 0);
		hMyModule= (HMODULE)hModule;
		break;

	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		if(bIsInjected)
		{	//RemoveProp(g_hSubWnd, "OldWndProc");
			SetWindowLong(g_hSubWnd, GWL_WNDPROC, lOldWndProc);
		}
		break;
	}
    return TRUE;
}

/////////////WINDOWS HOOK FUNCS/////////////////////////////////
bool SetMyHook(HWND hMWnd, HWND hSWnd)//SYSTEM-SCOPE, trig once by MyApp
{	g_hMyWnd= hMWnd;
	g_hSubWnd= hSWnd;
	
//force all process call LoadLibrary 
	g_hMyHook = SetWindowsHookEx(WH_CBT, MyHookProc, (HINSTANCE)hMyModule, 0);
	if(!g_hMyHook)
		return false;

	return true;
}
void ReleaseMyHook()//SYSTEM-SCOPE, trig once by MyApp
{	g_hMyWnd= NULL;
	
	if(g_hMyHook)
		UnhookWindowsHookEx(g_hMyHook);
}

//'Dump' hook func
LRESULT CALLBACK MyHookProc(int code, WPARAM wParam, LPARAM lParam)//PER-THREAD
{	//pass control to next hook.
	return CallNextHookEx(g_hMyHook,code,wParam,lParam);
}
BOOL CALLBACK EnumProc(HWND hwnd,LPARAM lParam) 
{ 	if(hwnd== g_hSubWnd)
	{	//replace Window Proc
		lOldWndProc = SetWindowLong(g_hSubWnd, GWL_WNDPROC, (LONG)SubClassWndProc);
		if(lOldWndProc)
		{	//Save Old Proc
			//SetProp(g_hSubWnd, "OldWndProc", (HANDLE)lOldWndProc); 
			bIsInjected= TRUE;
		}
		return FALSE; 
	}
	return TRUE;
} 
LRESULT CALLBACK SubClassWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{	switch(uMsg)
    {
    case WM_DESTROY:
        PostMessage(g_hMyWnd,WM_APP+10,0,0);
		MessageBox(NULL,"Destroyed","Warning!",MB_OK);
		//lRet= (LONG) GetProp(g_hSubWnd, (LPCSTR)"OldWndProc");
		//RemoveProp(hWnd, "OldWndProc");
		SetWindowLong(hWnd, GWL_WNDPROC, lOldWndProc);
		break;
    }

    return CallWindowProc((WNDPROC)lOldWndProc, hWnd, uMsg, wParam, lParam);
}
